angular.module('exceptionOverride', []).factory('$exceptionHandler', function () {
  return function (exception, cause) {
    Bugsnag.notifyException(exception, {diagnostics:{cause: cause}});
  };
});
var mainApp=angular.module("mainApp",['ngMessages']);

// mainApp.run(function($rootScope) {
//     angular.element(document).on("click", function(e) {
//         $rootScope.$broadcast("documentClicked", angular.element(e.target));
//     });
// });

mainApp.filter('arrayHasValue',function($filter){
    return function(input,bcardField){
        var result=false;
        var options=bcardField;
        if(options.hasOwnProperty(input)){
            result=true;
        }
        return result;
    }
});
mainApp.filter('pickInit',function($filter){
    return function(field){
        var result="-None-";
        var pl=field.pick_list_values;
        for(var i=0; i<pl.length;i++){
          if(i==0){
            result=pl[i].display_value;
          }
          if(pl[i].display_value=="-None-"){
            result="-None-";
            break;
          }
        }
        return result;
    }
});
mainApp.filter('countsTabsForListing',function($filter){
    return function(module,modulesList){
       var count=1;
       if(module=="contact"){
        var relatedMods=["Deals","Activities","Campaigns"];
        for(i=0;i<relatedMods.length;i++){
          if(modulesList.hasOwnProperty(relatedMods[i])){
            count++;
          }
        }
       }else if(module=="lead"){
        var relatedMods=["Activities","Campaigns"];
        for(i=0;i<relatedMods.length;i++){
          if(modulesList.hasOwnProperty(relatedMods[i])){
            count++;
          }
        }
       }else if(module=="extract"){
        var relatedMods=["Contacts","Leads"];
        for(i=0;i<relatedMods.length;i++){
          if(modulesList.hasOwnProperty(relatedMods[i])){
            count++;
          }
        }
       }
       return count;
    }
});
mainApp.filter('quickCreate',function($filter){
    return function(view,action,required){
        // var result=false;
        // if(action=='create' && view==true){
        //     result=true;
        // }else if(action=='create' && view==false){
        //     result=false;
        // }else{
        //   result=true;
        // }
        // if(required==true){
        //   result=true;
        // }
        // return result;
        return true;
    }
});
mainApp.filter('replaceKey',function($filter){
  return function(input,key,value){
    return input=input.replace(key,value);
  }
});
mainApp.filter('mentionCondition',function($filter){
  //ng-if="((result.full_name.toUpperCase().indexOf(mentionInput.toUpperCase())>-1)||(result.email.toUpperCase().indexOf(mentionInput.toUpperCase())>-1)) && !noteParams.mentions.hasOwnProperty(result.id)"
    return function(owner,noteParamsMentions,mentionInput){
        var result=false;
        // if(owner!=undefined && noteParamsMentions!=undefined && mentionInput!=undefined){
        //   console.log(":"+owner.full_name+":"+mentionInput+":");
        // }
        
        if(owner!=undefined && noteParamsMentions!=undefined && mentionInput!=undefined && ((owner.full_name.toUpperCase().indexOf(mentionInput.toUpperCase())>-1)||(owner.email.toUpperCase().indexOf(mentionInput.toUpperCase())>-1)) && !noteParamsMentions.hasOwnProperty(owner.id)){
          result = true;
        }
        return result;
    }
});
mainApp.filter('trimValue', function($filter) {
  return function(input) {
      var result = input.trim();
      return result || '';
  };
});

mainApp.directive('focus', function() {
    return function(scope, element, attrs) {
        scope.$watch(attrs.focus, function(newValue) {
            newValue && element[0].focus()
        })
    }
});
mainApp.filter('toSec', function($filter) {
  return function(input) {
      var result = new Date(input).getTime();
      return result || '';
  };
});

mainApp.filter('toSecWithTz', function($filter) {
  return function(input,timezone) {
      var result =  moment.tz(input, timezone).format();
      // console.log(result);
      return result || '';
    // console.log("result");  
  };
});

mainApp.filter('toTimeZoneNonFormated', function ($filter) { 
    return function (input) {
        var result  = input.substring(19,input.length).replace(":","");
        return result || '';
    };
});
mainApp.filter('toCommaSepNum', function($filter) {
  return function(input) {
      return input.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") || input;
  };
});
mainApp.filter('toColonSep',function($filter){
  return function(input){
    var result="";
    for(val of input){
      result += val+"; ";
    }
    // console.log(result);
    result = result.substring(0,result.length-2);
    return result || '';
  }
});
mainApp.filter('toColonSepObj',function($filter){
  return function(input){
    var result="";
    for(val of input){
      result += val.name+"; ";
    }
    // console.log(result);
    result = result.substring(0,result.length-2);
    return result || '';
  }
});
mainApp.filter('removeUnderscore',function($filter){
	return function(input){
		var result=input.replace(/_/g, " ");
		return result ||'';
	}
});
mainApp.filter('addUnderscore',function($filter){
    return function(input){
        var result=input.replace(/\+|\-|\'|( )/g, "_");
        return result ||'';
    }
});
mainApp.filter('isObject',function($filter){
	return function(input){
		var result=false;
    // console.log(Object.prototype.toString.call(input));
		if(Object.prototype.toString.call(input)=='[object Object]'){
			result=true;
		}
		return result;
	}
});
mainApp.filter('isBasicValidationSuccess',function($filter){
  return function(input,val1,val2){
    var result=false;
    // console.log(Object.prototype.toString.call(input));
    var x = parseFloat(input);
    if(input!=null && input!=undefined && input!=""){
      result=true;
    }else if(!isNaN(input) && (x | 0) === x){
      result=true;
    }
    // else if(!isNaN(input)){
    //   result=true;
    // }
    // console.log(val1+":"+val2+":"+input+":"+result+":"+(input!=null)+":"+(input!=undefined)+":"+(input!=""));
    return result;
  }
});
mainApp.filter('isArray',function($filter){
  return function(input){
    var result=false;
    // console.log(Object.prototype.toString.call(input));
    if(Object.prototype.toString.call(input)=='[object Array]'){
      // console.log(Object.prototype.toString.call(input));
      result=true;
    }
    return result;
  }
});
mainApp.filter('isTimeField',function($filter){
	return function(input){
		var result=false;
        var options=["Created_Time","Last_Activity_Time","Modified_Time"];
        if(options.indexOf(input)>=0){
            result=true;
        }
        return result;
	}
});
mainApp.filter('isDatetimeInView',function($filter){
  
  return function(input){
    var result=false;
        // var options=["Created_Time","Last_Activity_Time","Modified_Time"];
        // if(options.indexOf(input)>=0){
        //     result=true;
        // }
        var intTest=''+input;
        dt_regex=/^(\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}(\+|\-)\d{2}\:\d{2})$/gi;
        var dtformat=intTest.match(dt_regex);
        if(dtformat!=null){
          result=true;
        }
        return result;
  }
});
mainApp.filter('isDateInView',function($filter){
  
  return function(input){
    var result=false;
        // var options=["Created_Time","Last_Activity_Time","Modified_Time"];
        // if(options.indexOf(input)>=0){
        //     result=true;
        // }
        var intTest=''+input;
        dt_regex=/^(\d{4}\-\d{2}\-\d{2})$/gi;
        var dtformat=intTest.match(dt_regex);
        if(dtformat!=null){
          result=true;
        }
        return result;
  }
});
mainApp.filter('isNumeric',function($filter){
    return function(input){
        return !isNaN(input);
    }
});
mainApp.filter('toInitials',function($filter){
	return function(input){
        if(input!=null && input!=undefined){
            input+='';
            var name=input.split(" ");
            var result="";
            if(name.length>1){
                result +=name[0].substring(0,1)+name[1].substring(0,1);
            }else if(name.length==1){
                result +=name[0].substring(0,2);
            }else{
                result +=name.substring(0,2);
            }
        }
		return result || '';
	}
});
mainApp.directive('syncFocusWith', function($timeout, $rootScope) {
    return {
        restrict: 'A',
        scope: {
            focusValue: "=syncFocusWith"
        },
        link: function($scope, $element, attrs) {
            $scope.$watch("focusValue", function(currentValue, previousValue) {
                if (currentValue === true && !previousValue) {
                    $element[0].focus();
                } else if (currentValue === false && previousValue) {
                    $element[0].blur();
                }
            })
        }
    }
});


mainApp.directive('triggerFocusOn', function($timeout) {
    return {
        link: function(scope, element, attrs) {
            element.bind('click', function() {
                $timeout(function() {
                    var otherElement = document.querySelector('#' + attrs.triggerFocusOn);

                    if (otherElement) {
                        otherElement.focus();
                    }
                    else {
                        // console.log("Can't find element: " + attrs.triggerFocusOn);
                    }
                });
            });
        }
    };
});

mainApp.directive('triggerFocusOut', function($timeout) {
    return {
        link: function(scope, element, attrs) {
            element.bind('click', function() {
                $timeout(function() {
                    var otherElement = document.querySelector('#' + attrs.triggerFocusOut);

                    if (otherElement) {
                        otherElement.blur();
                    }
                    else {
                        // console.log("Can't find element: " + attrs.triggerFocusOut);
                    }
                });
            });
        }
    };
});

//directive for date picker

mainApp.directive("glDate", function($timeout, $parse) {
  return {
    restrict: 'AC',
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      // console.log(attrs);
      element.Zebra_DatePicker({
          onSelect: function(data) {
            element.trigger('change');
            },
            onClear:function(data){
              ngModel.$setViewValue();
            }
        });
    }
  };
});
function convertIsoToPhpFormat($format) {
  // alert("asdf");
    if ($format === null) {
        return null;
    }

    $convert = {"dd":"d","EE":"D","d":"j","EEEE":"l","eee":"N","SS":"S","e":"w","D":"z","ww":"W","MMMM":"F","MM":"m","MMM":"M","M":"n","ddd":"t","l":"L","YYYY":"o","yyyy":"Y","yy":"y","a":"a","A":"A","B":"B","h":"g","H":"G","hh":"h","HH":"H","mm":"i","ss":"s","zzzz":"e","I":"I","Z":"O","ZZZZ":"P","z":"T","X":"Z","ssZZZZ":"se","r":"r","U":"U"};

    // todo: add exceptions like yyyy-MM-ddTHH:mm:ssZZZZ
    for(var key in $convert){
      $format=$format.replace(key,$convert[key]);
    }
    // $result = '';
    // while ($arr_preg=$format.match('/^([^- :,]+)([- :,]*)(.*)$/')) {
    //   if (isset($convert[$arr_preg[1]]) === true) {
    //     $result += $convert[$arr_preg[1]];
    //   } else {
    //     $result += $arr_preg[1];
    //   }
    //   $result += $arr_preg[2];
    //   $format = $arr_preg[3];
    // }
    // while()
    // console.log($format);
    return $format;
}
//directive for getting count of li present in ul

mainApp.directive('countLiInUl',function(){
  return{
    require: '?ngModel',
    link: function(scope,element,attrs,ngModel){
      // console.log("in countLiInUl");
      element.on('DOMSubtreeModified', function($event){
        // console.log(element.size);
        // console.log($event.currentTarget.children.length);
        // if($event.currentTarget.children.length==0){
        //   scope.$apply(attrs.countLiInUl(0));
        // }else{
        //   scope.$apply(attrs.countLiInUl($event.currentTarget.children.length));
        // }
        // scope.$apply(attrs.countLiInUl);
        // element.data('numberOfLis', $event.currentTarget.children.length);
        // console.log($event)
        ngModel.$setViewValue(element.find("li").length);
      });

    }
  }
});

//directive for loading more items to the list

// mainApp.directive("moreItemsOnScroll",function(){
//   return {
//     restrict: 'AC',
//     require: 'ngModel',
//     link: function(scope, element, attrs, ngModel) {
//       // console.log(attrs);
     
//     }
//   };
// });
mainApp.directive('moreItemsOnScroll', function() {
    return {
        link : function(scope, element, attrs) {
            // console.log("scrolling of the directive");
            element.on('scroll', function($event) {
              // console.log("________________________________________");
              //  console.log("it is scrolling now");
              //  console.log("offsetHeight:"+$event.target.offsetHeight);
              //  console.log("offsetTop:"+$event.target.offsetTop);
              //  console.log("scrollHeight:"+$event.target.scrollHeight);
              //  console.log("clientHeight"+$event.target.clientHeight);
              //  console.log("scrollTop"+$event.target.scrollTop);
               // console.log($event);
              //  console.log(parseInt($event.target.scrollTop)+parseInt($event.target.offsetHeight));
              //  console.log(parseInt($event.target.scrollHeight));
              //  console.log($event.target.scrollTop+$event.target.offsetHeight==$event.target.scrollHeight);          
             
              //  if($event.target.scrollTop+$event.target.offsetHeight==$event.target.scrollHeight){
              //   // console.log("BOOOOOOOOOOOOOMMMMMMMMMMMMMM");
              //   scope.$apply(attrs.moreItemsOnScroll);
              //  }
              var containerHeight = $event.target.scrollHeight - $event.target.clientHeight;            
              var scrollPercentage = $event.target.scrollTop / containerHeight;
              scrollPercentage=scrollPercentage*100;
              // console.log(scrollPercentage);
              if(scrollPercentage>90){
                // console.log("BOOOOOOOOOOOOOMMMMMMMMMMMMMM");
                scope.$apply(attrs.moreItemsOnScroll);
              }
               if(element.data('old-value')==undefined){
                  element.data('old-value', $event.target.scrollTop);
               }
               if (element.data('old-value') != $event.target.scrollTop) {
                    // console.log($event);
                    // console.log('value changed, old value is: ' + element.data('old-value'));
                    // console.log('value changed, new value is: ' + $event.target.scrollTop);
                    // console.log("______________________");
                    if(parseInt(element.data('old-value'))<$event.target.scrollTop){
                      // console.log("scrolling up");
                      scope.$apply(attrs.scrollMovingUp);
                    }else if(parseInt(element.data('old-value'))>$event.target.scrollTop){
                      // console.log("scrolling down");
                      scope.$apply(attrs.scrollMovingDown);
                    }
                    element.data('old-value', $event.target.scrollTop);
                    // scope.$apply(function () {
                    //     scope.myDirective = element.val();
                    //     element.data('old-value', element.val());
                    // });
                }
               // if($event.target.scrollTop+$event.target.offsetHeight)
            });
            // element.on('scrollup', function($event) {
            //    console.log($event);
            //    // if($event.target.scrollTop+$event.target.offsetHeight==$event.target.scrollHeight){
            //    //  console.log("DDDDDDDDDDDDDDDOOOOOOOOOOOOOWWWWWWWWWWW");
            //    //  scope.$apply(attrs.moreItemsOnScroll);
            //    // }
            //    // if($event.target.scrollTop+$event.target.offsetHeight)
            // });
            // var offset = parseInt(attrs.threshold) || 0;
            // var e = jQuery(element[0]);
            // var doc = jQuery(document);
            // angular.element.bind('scroll', function() {
            //   console.log(doc.scrollTop()+":"+element.innerHeight+":"+offset+":"+e.offset().top);
            //     if (doc.scrollTop() + element.innerHeight + offset > e.offset().top) {
            //         scope.$apply(attrs.scrollTrigger);
            //     }
            // });
        }
    };
});



// directive for --no dirty check
// mainApp.directive('noDirtyCheck', function() {
//   // Interacting with input elements having this directive won't cause the
//   // form to be marked dirty.
//   return {
//     restrict: 'A',
//     require: 'ngModel',
//     link: function(scope, elm, attrs, ctrl) {
//       // console.log("************************");

//       // elm.removeClass("ng-dirty");

//       // console.log(ctrl.selected);
//       // ctrl.$dirty = true;
//       // ctrl.$setPristine();
//       // ctrl.$pristine = true;
//       // console.log(ctrl);
//       // ctrl.$setPristine();
//       // scope.$watch('ctrl.$viewValue',function(oldVal,newVal){
//       //   console.log(oldVal);
//       //   console.log(newVal);
//       //   if(oldVal!=newVal){
//       //     ctrl.$pristine = true;
//       //   }
//       // });
//       // console.log(elm[0]);
//       // console.log(elm.context.value);
//       // scope.$watch(elm[0].value,function(oldVal,newVal){
//       //   console.log(oldVal+"::"+newVal);
//       //   if(oldVal!=newVal){
//       //     ctrl.$pristine=true;
//       //   }
//       // });
//       // elm.focus(function () {
//       //     ctrl.$pristine = false;
//       // });
//     }
//   }
// });

//directive for contenteditable
mainApp.directive("contenteditable", function() {
  return {
    restrict: "ACE",
    require: "ngModel",
    scope:{
      notechange:"="
    },
    link: function(scope, element, attrs, ngModel) {

      function read() {
        ngModel.$setViewValue(element.html());
      }

      ngModel.$render = function() {
        element.html(ngModel.$viewValue || "");
      };

      element.bind("blur keyup change", function() {
        scope.$apply(read);
      });

      element.bind("keyup mouseup",function($event){
        if($event.keyCode==81){
                    // console.log("in 81");
                    var event=$event;
                    if(!ev) var ev = window.event;

                    ev.cancelBubble = true;
                    ev.returnValue = false;

                    if (ev.stopPropagation) {
                        ev.stopPropagation();
                        ev.preventDefault();
                    }
                }
        // console.log("directive:");
        var caretPos = 0,sel, range;
        // console.log(window.getSelection().getRangeAt(0));
        if(window.getSelection().rangeCount>0){
          // console.log(window.getSelection().getRangeAt(0));
          // console.log(window.getSelection().getRangeAt(0).endOffset);
          caretPos=window.getSelection().getRangeAt(0).startOffset;
        }
        // console.log(document.selection && document.selection.createRange);
        // if (window.getSelection()) {
        //   sel = window.getSelection();
        //   if (sel.rangeCount) {
        //     range = sel.getRangeAt(0);
        //     if (range.commonAncestorContainer.parentNode == editableDiv) {
        //       caretPos = range.endOffset;
        //     }
        //   }
        // } else if (document.selection && document.selection.createRange) {
        //   range = document.selection.createRange();
        //   if (range.parentElement() == editableDiv) {
        //     var tempEl = document.createElement("span");
        //     editableDiv.insertBefore(tempEl, editableDiv.firstChild);
        //     var tempRange = range.duplicate();
        //     tempRange.moveToElementText(tempEl);
        //     tempRange.setEndPoint("EndToEnd", range);
        //     caretPos = tempRange.text.length;
        //   }
        // }
        // console.log(caretPos);
        // scope.caretPos=caretPos;
        // element.prop("caretpos", caretPos);
        // scope.$apply();
        scope.$apply(scope.notechange($event,caretPos));
        // scope.$apply(attrs);

      });



    }
  };
});


//directive for lookupui
mainApp.directive("contactUi",function($timeout){
  return {
    restrict: 'ACE',
    require: '?ngModel',
    transclude: false,
    scope: {
      lookUpResults: '@',
      lookupLoading: '&',
      searchInput: '&',
      modulesList:'=modulesList'
    },
    templateUrl: 'create-form.html'
  }
});

mainApp.directive("lookupUi",function($timeout){
  return {
    restrict: 'ACE',
    require: '?ngModel',
    scope: {
      lookUpResults: '@',
      lookupLoading: '@',
      searchInput: '@'
    },
    templateUrl: '../templates/lookupui.html',
    link: function(scope, element, attrs, ngModel) {
      scope.lookupLoading='';
      scope.currentMod=attrs.lookupmodule.substring(0,attrs.lookupmodule.length-1);
      //icon lookup close click bind
      element.find("#lupIconClose").bind('click',function(){
        element.find('section').toggleClass('myhide');
        scope.searchInput=null;
      });
      element.find("#lupInput").bind('keyup',function($thiseve){
        if($thiseve.keyCode=="13" && $thiseve.currentTarget.value.length>0){
          scope.searchIconClick();
        }
      });
      $(document).bind('click', function(event){
        var isClickedElementChildOfPopup = element
            .find(event.target)
            .length > 0;
        if (isClickedElementChildOfPopup)
            return;
        // console.log(!element.find('section')[0].className.includes("myhide"));
        if(!element.find('section')[0].className.includes("myhide")){
          element.find('section').toggleClass('myhide');
          scope.searchInput=null;
        }
      });
      //icon lookup main click bind
      element.find('#lupIconMain').bind("click",function(){
        // console.dir($(document));
        scope.lookUpResults=[];
          // console.log(scope.lookupLoading);
          scope.lookupLoading='loading';
          scope.$apply();
          element.find('section').toggleClass('myhide');
          if(!element.find('section').hasClass('myhide')){
            // console.log("opened");
            element.find('#lupInput').val("");
            chrome.extension.sendRequest({name:'checkZatTime'},function(response){ 
              var thisurl="https://crm.zoho."+response.datacenterExt+"/crm/v2/"+attrs.lookupmodule;
              // console.log(thisurl); 
              if(response.status=="success"){
                chrome.extension.sendRequest({name:'apiCall',redirect:'',action:'GET',url:thisurl, body:'',zat:response.zat,orgId:response.orgId},function(response){
                  if(response.status==200){
                      // console.log(response.status);
                      // console.dir(response.resp);
                      var finalResp=JSON.parse(response.resp);
                      // console.dir(finalResp);
                      // console.dir(finalResp.data);
                      if(finalResp.data!=null){
                        // console.log("data not null");
                        scope.lookupLoading='';
                        scope.lookUpResults=finalResp.data;
                        // console.log(finalResp.data);
                        scope.$apply();
                        // $scope.safeApply();
                      }else{
                        scope.succErrorInit("error",response.message);
                        scope.lookupLoading='';
                        scope.$apply();
                      }
                  }else if(response.status==204){
                    // console.log(response.status);
                    scope.lookupLoading='noresults';
                    scope.$apply();
                  }else{
                      // console.log(response.status);
                      // console.dir(response.resp);
                      scope.lookupLoading='';
                      scope.succErrorInit("error",response.message);
                      scope.$apply();
                  }
                });
              }
            });
          }else{
            scope.searchInput=null;
          }
      });
      //icon inner search click bind
      scope.searchIconClick=function(){
        scope.lookUpResults=[];
          scope.lookupLoading='loading';
          // console.log("clicked search:"+element.find('#lupInput').val());
          // console.log(attrs);
          if(attrs.lookupmodule!=null && attrs.lookupmodule=="Accounts"){
            chrome.extension.sendRequest({name:'checkZatTime'},function(response){ 
              var thisurl="https://crm.zoho."+response.datacenterExt+"/crm/v2/"+attrs.lookupmodule+"/search?criteria=(Account_Name:starts_with:"+element.find('#lupInput').val()+")";
              // console.log(thisurl); 
              if(response.status=="success"){
                chrome.extension.sendRequest({name:'apiCall',redirect:'',action:'GET',url:thisurl, body:'',zat:response.zat,orgId:response.orgId},function(response){
                  if(response.status==200){
                      // console.log(response.status);
                      // console.dir(response.resp);
                      var finalResp=JSON.parse(response.resp);
                      // console.dir(finalResp);
                      // console.dir(finalResp.data);
                      if(finalResp.data!=null){
                        // console.log("data not null");
                        scope.lookupLoading='';
                        scope.lookUpResults=finalResp.data;
                        // console.log(finalResp.data);
                        scope.$apply();
                        // $scope.safeApply();
                      }else{
                        scope.succErrorInit("error",response.message);
                        scope.lookupLoading='';
                        scope.$apply();
                      }
                  }else if(response.status==204){
                    // console.log(response.status);
                    scope.lookupLoading='noresults';
                    scope.$apply();
                  }else{
                      // console.log(response.status);
                      // console.dir(response.resp);
                      scope.lookupLoading='';
                      scope.succErrorInit("error",response.message);
                      scope.$apply();
                  }
                });
              }
            });
          }
      }
      //options click binding
      scope.liClicked=function(result){
        // console.dir(result);
        if(attrs.lookupmodule!=null && attrs.lookupmodule=="Accounts"){
          ngModel.$setViewValue(result.Account_Name);
          element.find('section').toggleClass('myhide');
          scope.searchInput=null;
        }
      }
      scope.succErrorInit=function(succError,succErrorMsg){
          // console.log(succError+":::::"+succErrorMsg);
          scope.succError=succError;
          scope.succErrorMsg=succErrorMsg;
          if(succError!='loading'){
              $timeout(function(){
                  scope.succErrorReset();
              },4*1000);
          }
          scope.$apply();
      }
      scope.succErrorReset=function(){
        scope.succError='';
        scope.succErrorMsg='';
        scope.$apply();
      }


    }
  };
});


// directive for lookupownerui


mainApp.directive("lookupOwnerui",function($timeout,$filter){
  return {
    restrict: 'ACE',
    require: '?ngModel',
    scope: {
      lookUpResults: '@',
      lookupLoading: '@',
      searchInput: '@',
      modulesList:'=modulesList',
      todoStorage:'=todoStorage'
    },
    templateUrl: '../templates/lookupownerui.html',
    link: function(scope, element, attrs, ngModel) {
      scope.lookupLoading='';
      scope.searchInput='';
      if($filter("isBasicValidationSuccess")(attrs.lookupmodule)){
        scope.currentMod=attrs.lookupmodule.substring(0,attrs.lookupmodule.length-1);
      }
      else{
        scope.currentMod="Owner";
      }
      //icon lookup close click bind
      element.find("#lupIconClose").bind('click',function(){
        element.find('section').toggleClass('myhide');
      });
      $(document).bind('click', function(event){
        var isClickedElementChildOfPopup = element
            .find(event.target)
            .length > 0;
        if (isClickedElementChildOfPopup)
            return;
        // console.log(!element.find('section')[0].className.includes("myhide"));
        if(!element.find('section')[0].className.includes("myhide")){
          element.find('section').toggleClass('myhide');
          scope.searchInput=null;
        }
      });
      //icon lookup main click bind
      element.find('#lupIconMain').bind("click",function(){
          scope.lookupLoading='loading';
          scope.lookUpResults=[];
          scope.$apply();
          element.find('section').toggleClass('myhide');
          if(!element.find('section').hasClass('myhide')){
            // console.log("opened");
            element.find('#lupInput').val("");
            scope.$parent.todoStorage.usersList(function(data){ 
              // console.log(data[0]);
              scope.lookUpResults=data;
              scope.lookupLoading='';
              scope.searchInput='';
              scope.$apply();
            });
          }
      });
      scope.searchIconClick=function(){
          // console.log("clicked search:"+element.find('#lupInput').val());
          scope.lookupLoading='loading';
          scope.lookUpResults=[];
          // console.log(attrs);
          scope.$parent.todoStorage.usersList(function(data){ 
                  // console.log(data[0]);
                  scope.lookUpResults=data;
                  scope.lookupLoading='';
                  scope.$apply();
          });
      }
      //options click binding
      scope.liClicked=function(result){
        // console.dir(result);
        // if(attrs.lookupmodule!=null && attrs.lookupmodule=="Accounts"){
          ngModel.$setViewValue({'name':result.full_name,'id':result.id});
          // console.log(ngModel);
          // console.log(scope.addFormData);
          // scope.addFormData[attrs.fieldapiname].name=result.full_name;
          element.find('section').toggleClass('myhide');
        // }
      }
      scope.succErrorInit=function(succError,succErrorMsg){
          // console.log(succError+":::::"+succErrorMsg);
          scope.succError=succError;
          scope.succErrorMsg=succErrorMsg;
          if(succError!='loading'){
              $timeout(function(){
                  scope.succErrorReset();
              },4*1000);
          }
          scope.$apply();
      }
      scope.succErrorReset=function(){
        scope.succError='';
        scope.succErrorMsg='';
        scope.$apply();
      }


    }
  };
});



//directive for lookupotherui

mainApp.directive("lookupOtherui",function($timeout){
  return {
    restrict: 'ACE',
    require: '?ngModel',
    scope: {
      lookUpResults: '@',
      lookupLoading: '@',
      searchInput: '@',
      modulesList:'=modulesList'
    },
    templateUrl: '../templates/lookupothersui.html',
    link: function(scope, element, attrs, ngModel) {
      scope.lookupLoading='';
      scope.currentMod=attrs.lookupmodule.substring(0,attrs.lookupmodule.length-1);
      scope.moduleFields=[{"Contacts":"Full_Name"},{"Leads":"Full_Name"},{"Accounts":"Account_Name"},{"Deals":"Deals_Name"},{"Campaigns":"Campaign_Name"},{"Vendors":"Vendor_Name"},{"Cases":"Subject"},{"Solutions":"Solution_Title"},{"Products":"Product_Name"},{"Quotes":"Subject"},{"Invoices":"Subject"},{"Price_Books":"Price_Book_Name"},{"Sales_Orders":"Subject"},{"Purchase_Orders":"Subject"}];
      scope.moduleField="";
      angular.forEach(scope.moduleFields, function(mf) {
        if(mf[attrs.lookupmodule]!=null){
          scope.moduleField=mf[attrs.lookupmodule];
        }
      });
      //icon lookup close click bind
      element.find("#lupIconClose").bind('click',function(){
        element.find('section').toggleClass('myhide');
        scope.searchInput=null;
      });
      element.find("#lupInput").bind('keyup',function($thiseve){
        if($thiseve.keyCode=="13" && $thiseve.currentTarget.value.length>0){
          scope.searchIconClick();
        }
      });
      $(document).bind('click', function(event){
        var isClickedElementChildOfPopup = element
            .find(event.target)
            .length > 0;
        if (isClickedElementChildOfPopup)
            return;
        // console.log(!element.find('section')[0].className.includes("myhide"));
        if(!element.find('section')[0].className.includes("myhide")){
          element.find('section').toggleClass('myhide');
          scope.searchInput=null;
        }
      });
      //icon lookup main click bind
      element.find('#lupIconMain').bind("click",function(){
          scope.lookupLoading='loading';
          scope.lookUpResults=[];
          // console.log(scope.lookupLoading);
          scope.$apply();
          element.find('section').toggleClass('myhide');
          if(!element.find('section').hasClass('myhide')){
            // console.log("opened");
            element.find('#lupInput').val("");
            chrome.extension.sendRequest({name:'checkZatTime'},function(response){  
              var thisurl="https://crm.zoho."+response.datacenterExt+"/crm/v2/"+attrs.lookupmodule;
              // console.log(thisurl);
              if(response.status=="success"){
                chrome.extension.sendRequest({name:'apiCall',redirect:'',action:'GET',url:thisurl, body:'',zat:response.zat,orgId:response.orgId},function(response){
                  if(response.status==200){
                      // console.log(response.status);
                      // console.dir(response.resp);
                      var finalResp=JSON.parse(response.resp);
                      // console.dir(finalResp);
                      // console.dir(finalResp.data);
                      if(finalResp.data!=null){
                        // console.log("data not null");
                        scope.lookupLoading='';
                        // console.log(scope.lookUpResults);
                        scope.lookUpResults=finalResp.data;
                        // console.log(finalResp.data);
                        scope.$apply();
                        // $scope.safeApply();
                      }else{
                        scope.succErrorInit("error",response.message);
                        scope.lookupLoading='';
                        scope.$apply();
                      }
                  }else if(response.status==204){
                      // console.log(response.status);
                      scope.lookupLoading='noresults';
                      scope.$apply();
                  }else{
                      // console.log(response.status);
                      // console.dir(response.resp);
                      scope.lookupLoading='';
                      scope.succErrorInit("error",response.message);
                      scope.$apply();
                  }
                });
              }
            });
          }else{
            scope.searchInput=null;
          }
      });
      element.find("#clearLookUp").bind("click",function(){
        ngModel.$setViewValue(null);
      });
      //icon inner search click bind
      scope.searchIconClick=function(){
          // console.log("clicked search:"+element.find('#lupInput').val());
          scope.lookupLoading='loading';
          scope.lookUpResults=[];
          // console.log(attrs);
          if(attrs.lookupmodule!=null && scope.moduleField!=""){
            chrome.extension.sendRequest({name:'checkZatTime'},function(response){  
              var thisurl="https://crm.zoho."+response.datacenterExt+"/crm/v2/"+attrs.lookupmodule+"/search?criteria=("+scope.moduleField+":starts_with:"+element.find('#lupInput').val()+")";
              // console.log(thisurl);
              if(response.status=="success"){
                chrome.extension.sendRequest({name:'apiCall',redirect:'',action:'GET',url:thisurl, body:'',zat:response.zat,orgId:response.orgId},function(response){
                  if(response.status==200){
                      // console.log(response.status);
                      // console.dir(response.resp);
                      var finalResp=JSON.parse(response.resp);
                      // console.dir(finalResp);
                      // console.dir(finalResp.data);
                      if(finalResp.data!=null){
                        // console.log("data not null");
                        scope.lookupLoading='';
                        scope.lookUpResults=finalResp.data;
                        // console.log(finalResp.data);
                        scope.$apply();
                        // $scope.safeApply();
                      }else{
                        scope.succErrorInit("error",response.message);
                        scope.succErrorInit("error",response.message);
                        scope.lookupLoading='';
                        scope.$apply();
                      }
                  }else if(response.status==204){
                      // console.log(response.status);
                      // console.dir(response.resp);
                      scope.lookupLoading='noresults';
                      scope.$apply();
                  }else{
                      // console.log(response.status);
                      // console.dir(response.resp);
                      scope.lookupLoading='';
                      scope.succErrorInit("error",response.message);
                      scope.$apply();
                  }
                });
              }
            });
          }
      }
      //options click binding
      scope.liClicked=function(result){
        // console.dir(result);
        if(attrs.lookupmodule!=null){
          ngModel.$setViewValue({'name':result[scope.moduleField],'id':result.id});
          element.find('section').toggleClass('myhide');
          scope.searchInput=null;
        }
      }
      scope.succErrorInit=function(succError,succErrorMsg){
          // console.log(succError+":::::"+succErrorMsg);
          scope.succError=succError;
          scope.succErrorMsg=succErrorMsg;
          if(succError!='loading'){
              $timeout(function(){
                  scope.succErrorReset();
              },4*1000);
          }
          scope.$apply();
      }
      scope.succErrorReset=function(){
        scope.succError='';
        scope.succErrorMsg='';
        scope.$apply();
      }

    }
  };
});



//directive for select and multiselect ui

var __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };
mainApp.directive('chosenSelect', [
    '$timeout', function($timeout) {
      var CHOSEN_OPTION_WHITELIST, NG_OPTIONS_REGEXP, isEmpty, snakeCase;
      NG_OPTIONS_REGEXP = /^\s*(.*?)(?:\s+as\s+(.*?))?(?:\s+group\s+by\s+(.*))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+(.*?)(?:\s+track\s+by\s+(.*?))?$/;
      CHOSEN_OPTION_WHITELIST = ['noResultsText', 'allowSingleDeselect', 'disableSearchThreshold', 'disableSearch', 'enableSplitWordSearch', 'inheritSelectClasses', 'maxSelectedOptions', 'placeholderTextMultiple', 'placeholderTextSingle', 'searchContains', 'singleBackstrokeDelete', 'displayDisabledOptions', 'displaySelectedOptions', 'width'];
      snakeCase = function(input) {
        return input.replace(/[A-Z]/g, function($1) {
          return "_" + ($1.toLowerCase());
        });
      };
      isEmpty = function(value) {
        var key;
        if (angular.isArray(value)) {
          return value.length === 0;
        } else if (angular.isObject(value)) {
          for (key in value) {
            if (value.hasOwnProperty(key)) {
              return false;
            }
          }
        }
        return true;
      };
      return {
        restrict: 'A',
        require: '?ngModel',
        priority: 1,
        link: function(scope, element, attr, ngModel) {
          var chosen, defaultText, disableWithMessage, empty, initOrUpdate, match, options, origRender, removeEmptyMessage, startLoading, stopLoading, valuesExpr, viewWatch;
          // alert("0.2");
          element.addClass('localytics-chosen');
          // alert("0.1");
          options = scope.$eval(attr.chosen) || {};
          // alert("1");
          angular.forEach(attr, function(value, key) {
            
            if (__indexOf.call(CHOSEN_OPTION_WHITELIST, key) >= 0) {
              // console.log(CHOSEN_OPTION_WHITELIST+" :: "+key);
              return options[snakeCase(key)] = scope.$eval(value);
            }
          });
          // alert("2");
          startLoading = function() {
            return element.addClass('loading').attr('disabled', true).trigger('chosen:updated');
          };
          stopLoading = function() {
            return element.removeClass('loading').attr('disabled', false).trigger('chosen:updated');
          };
          chosen = null;
          defaultText = null;
          empty = false;
          initOrUpdate = function() {
            if (chosen) {
              // alert("in if");
              return element.trigger('chosen:updated');
            } else {
              // alert("in else");
              chosen = element.chosen(options).data('chosen');
              // console.log(chosen);
              return defaultText = chosen.default_text;
            }
          };
          removeEmptyMessage = function() {
            empty = false;
            return element.attr('data-placeholder', defaultText);
          };
          disableWithMessage = function() {
            empty = true;
            return element.attr('data-placeholder', chosen.results_none_found).attr('disabled', true).trigger('chosen:updated');
          };
          if (ngModel) {
            // alert("3");
            origRender = ngModel.$render;
            ngModel.$render = function() {
              origRender();
              return initOrUpdate();
            };
            if (attr.multiple) {
              viewWatch = function() {
                return ngModel.$viewValue;
              };
              scope.$watch(viewWatch, ngModel.$render, true);
            }
          } else {
            // alert("4");
            initOrUpdate();
          }
          attr.$observe('disabled', function() {
            return element.trigger('chosen:updated');
          });
          if (attr.ngOptions && ngModel) {
            // alert("5");
            match = attr.ngOptions.match(NG_OPTIONS_REGEXP);
            valuesExpr = match[7];
            scope.$watchCollection(valuesExpr, function(newVal, oldVal) {
              var timer;
              return timer = $timeout(function() {
                if (angular.isUndefined(newVal)) {
                  // alert("6");
                  return startLoading();
                } else {
                  // alert("7");
                  if (empty) {
                    removeEmptyMessage();
                  }
                  stopLoading();
                  if (isEmpty(newVal)) {
                    // alert("8");
                    return disableWithMessage();
                  }
                }
              });
            });
            // alert("9");
            return scope.$on('$destroy', function(event) {
              if (typeof timer !== "undefined" && timer !== null) {
                return $timeout.cancel(timer);
              }
            });
          }
        }
      };
    }
  ]);


mainApp.factory('sharedData', ['$rootScope', '$window', function ($rootScope, $window) {
    // console.log("in sharedData factory");
    var // Variables
        dataScope,

        // Functions
        getScope;

    dataScope = $rootScope.$new(true);

    getScope = function () {
        return dataScope;
    };

    $window.sharedData = {
        getScope: getScope
    };

    return {
        getScope: getScope
    };
}]);