var mainApp=angular.module("mainApp",['ngSanitize', 'ui.select']);

mainApp.filter('toSec', function($filter) {
  return function(input) {
      var result = new Date(input).getTime();
      return result || '';
  };
});
mainApp.filter('removeUnderscore',function($filter){
    return function(input){
        var result=input.replace(/_/g, " ");
        return result ||'';
    }
});
mainApp.filter('isObject',function($filter){
    return function(input){
        var result=false;
        if(Object.prototype.toString.call(input)=='[object Object]'){
            result=true;
        }
        return result;
    }
});
mainApp.filter('isTimeField',function($filter){
    return function(input){
        var result=false;
        var options=["Created_Time","Last_Activity_Time","Modified_Time"];
        if(options.indexOf(input)>=0){
            result=true;
        }
        return result;
    }
});
mainApp.filter('isNumeric',function($filter){
    return function(input){
        return !isNaN(input);
    }
});
mainApp.filter('toInitials',function($filter){
    return function(input){
        var name=input.split(" ");
        var result="";
        if(name.length>1){
            result +=name[0].substring(0,1)+name[1].substring(0,1);
        }else if(name.length==1){
            result +=name[0].substring(0,2);
        }else{
            result +=name.substring(0,2);
        }
        return result || '';
    }
});
mainApp.directive('syncFocusWith', function($timeout, $rootScope) {
    return {
        restrict: 'A',
        scope: {
            focusValue: "=syncFocusWith"
        },
        link: function($scope, $element, attrs) {
            $scope.$watch("focusValue", function(currentValue, previousValue) {
                if (currentValue === true && !previousValue) {
                    $element[0].focus();
                } else if (currentValue === false && previousValue) {
                    $element[0].blur();
                }
            })
        }
    }
});
mainApp.directive('date', function (dateFilter) {
    // return {
    //     restrict: 'A',
    //     require: 'ngModel',
    //     link: function (scope, element, attrs, ngModel) {
    //         var moment = $window.moment;

    //         ngModel.$formatters.push(formatter);
    //         ngModel.$parsers.push(parser);

    //         element.on('change', function (e) {
    //             var element = e.target;
    //             element.value = formatter(ngModel.$modelValue);
    //         });

    //         function parser(value) {
    //             var m = moment(value);
    //             var valid = m.isValid();
    //             ngModel.$setValidity('datetime', valid);
    //             if (valid) return m.valueOf();
    //             else return value;
    //         }

    //         function formatter(value) {
    //             var m = moment(value);
    //             var valid = m.isValid();
    //             if (valid) return m.format("LLLL");
    //             else return value;

    //         }

    //     } //link
    // };
    // return {
    //     restrict: 'A',
    //     require: 'ngModel',
    //      link: function (scope, element, attrs, ngModelCtrl) {
    //         element.datepicker({
    //             dateFormat: 'dd/mm/yy',
    //             onSelect: function (date) {   
    //                 var ar=date.split("/");
    //                 date=new Date(ar[2]+"-"+ar[1]+"-"+ar[0]);
    //                 ngModelCtrl.$setViewValue(date.getTime());            
    //                 scope.$apply();
    //             }
    //         });
    //         ngModelCtrl.$formatters.unshift(function(v) {
    //         return $filter('date')(v,'dd/MM/yyyy'); 
    //         });

    //     }
    // };
    return {
        require:'ngModel',
        link:function (scope, elm, attrs, ctrl) {

            var dateFormat = attrs['date'] || 'yyyy-MM-dd';
            elm.on('change', function (e) {
                // console.log("changed:"+elm.val());
                scope.$eval(attrs.ngModel + "=" + elm.val());
                $scope.$apply();  
                // ctrl.$formatters.unshift(function (modelValue) {
                //     console.log("in ctrl");
                //     return dateFilter(modelValue, dateFormat);
                // });
            });
            
        }
    };

}); //appDatetime


mainApp.directive('triggerFocusOn', function($timeout) {
    return {
        link: function(scope, element, attrs) {
            element.bind('click', function() {
                $timeout(function() {
                    var otherElement = document.querySelector('#' + attrs.triggerFocusOn);

                    if (otherElement) {
                        otherElement.focus();
                    }
                    else {
                        console.log("Can't find element: " + attrs.triggerFocusOn);
                    }
                });
            });
        }
    };
});

mainApp.directive('triggerFocusOut', function($timeout) {
    return {
        link: function(scope, element, attrs) {
            element.bind('click', function() {
                $timeout(function() {
                    var otherElement = document.querySelector('#' + attrs.triggerFocusOut);

                    if (otherElement) {
                        otherElement.blur();
                    }
                    else {
                        console.log("Can't find element: " + attrs.triggerFocusOut);
                    }
                });
            });
        }
    };
});
mainApp.factory('sharedData', ['$rootScope', '$window', function ($rootScope, $window) {
    console.log("in sharedData factory");
    var // Variables
        dataScope,

        // Functions
        getScope;

    dataScope = $rootScope.$new(true);

    getScope = function () {
        return dataScope;
    };

    $window.sharedData = {
        getScope: getScope
    };

    return {
        getScope: getScope
    };
}]);



mainApp.filter('propsFilter', function() {
  return function(items, props) {
    var out = [];

    if (angular.isArray(items)) {
      var keys = Object.keys(props);
        
      items.forEach(function(item) {
        var itemMatches = false;

        for (var i = 0; i < keys.length; i++) {
          var prop = keys[i];
          var text = props[prop].toLowerCase();
          if (item[prop].toString().toLowerCase().indexOf(text) !== -1) {
            itemMatches = true;
            break;
          }
        }

        if (itemMatches) {
          out.push(item);
        }
      });
    } else {
      // Let the output be the input untouched
      out = items;
    }

    return out;
  };
});


