mainApp.controller('accountDetails',function($scope, $element,$http, $timeout, todoStorage, sharedData){

  $scope.safeApply = function(fn) {   /* used in todoStorage for data binding */
      var phase = this.$root.$$phase;
      if(phase == '$apply' || phase == '$digest') {
        if(fn && (typeof(fn) === 'function')) {
          fn();
        }
      } else {
        this.$apply(fn);
      }
    };
    $scope.todoStorage = todoStorage;   /* got from a mainApp service used to fetch data from chrome db */
  $scope.exti18n={};
  $scope.todoStorage.currentUserData(function(data){
    if(data!=null){
      $scope.currentUserData=data.users[0];
    }
    // console.log($scope.currentUserData);
    if($scope.currentUserData!=undefined && lang_i18n["lang_"+$scope.currentUserData.language]!=undefined){
      $scope.exti18n=lang_i18n["lang_"+$scope.currentUserData.language];
    }else{
      $scope.exti18n=lang_i18n["lang_en_US"];
    }
    
    $scope.safeApply($scope.exti18n);
  });
  $scope.safeApply($scope.exti18n);
  $scope.webpage ="Gmail";
  chrome.extension.sendRequest({name:'getwebpage'},function(resp){
    // console.log(resp);
    $scope.webpage=resp;
    $scope.safeApply();
  });
    // console.log("in accountDetails");
    $scope.showFullScreen=false; /* shows the screen after full html loaded if true*/
    $scope.showSignoutLoading=false;
  $scope.deleteYesOrNo="hide";
    $scope.quitYesOrNo='hide';
    $scope.succError='';/*success for success, error for error,loading for loading */
    $scope.succErrorMsg='';
    $scope.currentModule='Account';
    $scope.windowPixelChanged=false;
    $scope.mainpage=null;
    $scope.modulesList={};
    chrome.extension.sendRequest({name:'',redirect:'getMainPage',action:'getMainPage'},function(resp){
      // console.log(resp);
      $scope.mainpage=resp;
      $scope.safeApply();
    });
    chrome.extension.onRequest.addListener(function(request, sender, sendResponse) {
      // console.log("received in iframe");
      var name = request.name; 
      var redirect =request.redirect;
      switch(redirect){
        case 'toIframe':
        // console.log("inside toIframe");
          $scope.mainpage=request.val;
          $scope.safeApply();
        break;
      }
    });
    $scope.sharedData = sharedData.getScope();
    // console.log($scope.sharedData);
    $scope.todoStorage.modulesList(function(data){
      $scope.modulesList=data;
      $scope.safeApply();
      // console.log($scope.modulesList);
    });
    $scope.todoStorage.accountsMetadata(function(data){
    var items=data.modules[0].layouts;
        // angular.forEach(items,function(item){
        //     if(item.name=="Standard"){
        //         $scope.layout=item;
        //     }
        // });
        // if($scope.layout==undefined && items.length>0){
        //          $scope.layout=items[0];
        //     }

        for(var item in items){
            for (var profile in items[item].profiles) {
                if (items[item].profiles[profile].id == $scope.currentUserData.profile.id && items[item].profiles[profile].default == true) {
                    $scope.layout = items[item];
                    break;
                }
            }
        }
        // console.dir($scope.layout);
        $scope.fields=data.modules[0].fields;
        $scope.harcodedFields={};
        var resultArray=[];
        for(var sec=0;sec<$scope.layout.sections.length;sec++){
            for(var fld=0;fld<$scope.layout.sections[sec].fields.length;fld++){
                var result={};
                var retObj=findAndReturn($scope.fields,'api_name',$scope.layout.sections[sec].fields[fld].api_name);
                for(var key in retObj){
                    result[key]=retObj[key];
                }
                for(var key in $scope.layout.sections[sec].fields[fld]){
                    result[key]=$scope.layout.sections[sec].fields[fld][key];
                }
                $scope.harcodedFields[result.api_name]=result;
                // $scope.layout.sections[sec].fields[fld]=result;
                resultArray.push(result);
            }
        }
        // console.log("combinedFields:");
        // console.dir(resultArray);
        $scope.combinedFields=resultArray;
        $scope.safeApply();
  });
    $scope.todoStorage.accountsListFromMenu(function(data){
        var result = [];
        $scope.moduleData=data;
        $scope.details=data.data;
        $scope.sharedData.data=data.data;
        // console.dir($scope.details);

        $scope.infoOfDetails=data.info;
       $scope.currentListPageNumber=1;

        if($scope.details==undefined){
          $scope.showAccountList="error";
          $scope.details=[];
          $scope.sharedData.data=[];
        }else if($scope.details.length==0){
          $scope.showAccountList="noresults";
        }else{
			$scope.showAccountList="show";
		}
        $scope.showFullScreen=true; 
        $scope.safeApply();
    });
    $scope.getFullAccount=function(id){
      var innerEl=document.createElement("iframe");
      innerEl.className="inner-account-iframe";
      innerEl.id="zc_innerIframePage";
      innerEl.name="zc_innerIframePage";
      innerEl.src=chrome.extension.getURL('html/account-inner.html');
      innerEl.setAttribute('frameborder','0');
      // console.dir(angular.element('#zc_innerIframeParentDiv'));
      angular.element('#zc_innerIframeParentDiv').append(innerEl);
      $scope.sharedData.id=id;
      $scope.sharedData.module="Account";
      $scope.sharedData.moduleData=$scope.moduleData;
      $scope.sharedData.harcodedFields=$scope.harcodedFields;
      $scope.safeApply();
      if($scope.windowPixelChanged==false){
        chrome.extension.sendRequest({name:'',redirect:'resetWinSize',action:'resetWinSize'},function(resp){});
        $scope.windowPixelChanged=true;
        $scope.safeApply();
      }
    }
    $scope.deleteAccount=function(id){
      if($scope.modulesList.Accounts!=null && $scope.modulesList.Accounts.deletable==false){
            $scope.sharedData.succErrorInit('error',$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        if($scope.layout.visible!=null && $scope.layout.visible!=undefined && $scope.layout.visible==false){
            $scope.sharedData.succErrorInit('error',"***"+$scope.modulesList.Accounts.singular_label+" "+$scope.layout.name+" Layout"+"*** "+$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        // console.log("deleteAccount function executing");
      $scope.deleteYesOrNo="show";
        $scope.safeApply();
        var unregister = $scope.$watch('deleteYesOrNo', function () {
            if($scope.deleteYesOrNo=='yes'){
                $scope.deleteYesOrNo="hide";
                $scope.sharedData.succErrorInit('loading',$scope.exti18n.ppw);
                chrome.extension.sendRequest({name:'checkZatTime'},function(response){  
                if(response.status=="success"){
                  var config = {headers:  { 'Authorization': 'Zoho-oauthtoken '+response.zat ,'X-ZOHO-SERVICE':'gadgets','X-CRM-ORG':response.orgId}};
                  var url='https://crm.zoho.'+response.datacenterExt+'/crm/v2/Accounts/'+id;
                  var deleteAccount=$http.delete(url,config);
                  deleteAccount.success( function(resp, status, headers, config) {
                      // console.log("deleted response:");
                      // console.log(status)
                      // console.dir(resp);
                      if(status==200){
                          // console.log("success Account deleted");
                          findAndRemove($scope.details, 'id', id);
                          if($scope.details.length<=0){
                              $scope.showAccountList='noresults';
                          }
                          // console.log("goBack code is executing in sharedData.deleteAccount");
                          $scope.sharedData.id=null;
                          $scope.$applyAsync();
                          // document.getElementById('zc_innerIframeParentDiv').removeChild(document.getElementById('zc_innerIframePage'));
                          $scope.sharedData.succErrorInit('success',$scope.exti18n.delSuc.replace("{{module}}",$scope.modulesList.Accounts.singular_label));
                      }else{
                        $scope.sharedData.succErrorInit('error',resp.message);
                      }
                  });
                  deleteAccount.error(function(resp, status,headers,config){
                          // console.log("failure Account not deleted");
                          // console.log(status);
                          // // console.dir(resp);
                          $scope.sharedData.succErrorInit('error',resp.message);
                  });
                  $scope.safeApply();
                }else{
                  $scope.sharedData.succErrorReset();
                }
              });
                unregister();
            }else if($scope.deleteYesOrNo=='no'){
                // console.log("no clicked");
                $scope.deleteYesOrNo="hide";
                unregister();
            }
        });
    }
    $scope.sharedData.deleteAccount=function(id){
      if($scope.modulesList.Accounts!=null && $scope.modulesList.Accounts.deletable==false){
            $scope.sharedData.succErrorInit('error',$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        if($scope.layout.visible!=null && $scope.layout.visible!=undefined && $scope.layout.visible==false){
            $scope.sharedData.succErrorInit('error',"***"+$scope.modulesList.Accounts.singular_label+" "+$scope.layout.name+" Layout"+"*** "+$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
      // console.log("deleteAccount function executing");
      $scope.deleteYesOrNo="show";
        $scope.safeApply();
        var unregister = $scope.$watch('deleteYesOrNo', function () {
            if($scope.deleteYesOrNo=='yes'){
                $scope.deleteYesOrNo="hide";
                $scope.sharedData.succErrorInit('loading',$scope.exti18n.ppw);
                chrome.extension.sendRequest({name:'checkZatTime'},function(response){  
                if(response.status=="success"){
                  var config = {headers:  { 'Authorization': 'Zoho-oauthtoken '+response.zat ,'X-ZOHO-SERVICE':'gadgets','X-CRM-ORG':response.orgId}};
                  var url='https://crm.zoho.'+response.datacenterExt+'/crm/v2/Accounts/'+id;
                  var deleteAccount=$http.delete(url,config);
                  deleteAccount.success( function(resp, status, headers, config) {
                      // console.log("deleted response:");
                      // console.log(status)
                      // // console.dir(resp);
                      if(status==200){
                          // console.log("success Account deleted");
                          findAndRemove($scope.details, 'id', id);
                          if($scope.details.length<=0){
                              $scope.showAccountList='noresults';
                          }
                          // console.log("goBack code is executing in sharedData.deleteAccount");
                          $scope.sharedData.id=null;
                          $scope.$applyAsync();
                          document.getElementById('zc_innerIframeParentDiv').removeChild(document.getElementById('zc_innerIframePage'));
                          $scope.sharedData.succErrorInit('success',$scope.exti18n.delSuc.replace("{{module}}",$scope.modulesList.Accounts.singular_label));
                      }else{
                        $scope.sharedData.succErrorInit('error',resp.message);
                      }
                  });
                  deleteAccount.error(function(resp, status,headers,config){
                          // console.log("failure Account not deleted");
                          // console.log(status);
                          // // console.dir(resp);
                          $scope.sharedData.succErrorInit('error',resp.message);
                  });
                  $scope.safeApply();
                }else{
                  $scope.sharedData.succErrorReset();
                }
              });
                unregister();
            }else if($scope.deleteYesOrNo=='no'){
                // console.log("no clicked");
                $scope.deleteYesOrNo="hide";
                unregister();
            }
        });
    }
    $scope.sharedData.editAccount=function(id){
      if($scope.modulesList.Accounts!=null && $scope.modulesList.Accounts.editable==false){
            $scope.sharedData.succErrorInit('error',$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        if($scope.layout.visible!=null && $scope.layout.visible!=undefined && $scope.layout.visible==false){
            $scope.sharedData.succErrorInit('error',"***"+$scope.modulesList.Accounts.singular_label+" "+$scope.layout.name+" Layout"+"*** "+$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        // console.log("editAccount clicked");
      var innerEl=document.createElement("iframe");
      innerEl.className="inner-account-iframe";
      innerEl.id="zc_innerIframePage";
      innerEl.name="zc_innerIframePage";
      innerEl.src=chrome.extension.getURL('html/create-account.html');
      innerEl.setAttribute('frameborder','0');
      // console.dir(angular.element('#zc_innerIframeParentDiv'));
      angular.element('#zc_innerIframeParentDiv').empty();
      angular.element('#zc_innerIframeParentDiv').append(innerEl);
      $scope.sharedData.id=id;
      $scope.sharedData.module="Account";
      $scope.sharedData.moduleData=$scope.moduleData;
      $scope.sharedData.action="edit";
      $scope.safeApply();
      if($scope.windowPixelChanged==false){
        chrome.extension.sendRequest({name:'',redirect:'resetWinSize',action:'resetWinSize'},function(resp){});
        $scope.windowPixelChanged=true;
        $scope.safeApply();
      }
    }
    $scope.createAccount=function(){
      if($scope.modulesList.Accounts!=null && $scope.modulesList.Accounts.creatable==false){
            $scope.sharedData.succErrorInit('error',$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
        if($scope.layout.visible!=null && $scope.layout.visible!=undefined && $scope.layout.visible==false){
            $scope.sharedData.succErrorInit('error',"***"+$scope.modulesList.Accounts.singular_label+" "+$scope.layout.name+" Layout"+"*** "+$scope.exti18n.perDenied+", "+$scope.exti18n.pca);
            return;
        }
      // console.log("createAccount clicked");
      var innerEl=document.createElement("iframe");
      innerEl.className="inner-account-iframe";
      innerEl.id="zc_innerIframePage";
      innerEl.name="zc_innerIframePage";
      innerEl.src=chrome.extension.getURL('html/create-account.html');
      innerEl.setAttribute('frameborder','0');
      // console.dir(angular.element('#zc_innerIframeParentDiv'));
      angular.element('#zc_innerIframeParentDiv').empty();
      angular.element('#zc_innerIframeParentDiv').append(innerEl);
      // $scope.sharedData.id=id;
      $scope.sharedData.module="Account";
      $scope.sharedData.moduleData=$scope.moduleData;
      $scope.sharedData.action="create";
      $scope.safeApply();
      if($scope.windowPixelChanged==false){
        chrome.extension.sendRequest({name:'',redirect:'resetWinSize',action:'resetWinSize'},function(resp){});
        $scope.windowPixelChanged=true;
        $scope.safeApply();
      }
    }
    $scope.sharedData.updatedAccountListAfterAccountAdded=function(addedAccount){
      // console.log(addedAccount);
      $scope.details.unshift(addedAccount);
      $scope.goBackChild();
      $scope.getFullAccount(addedAccount.id);
      $scope.showAccountList="show";
      $scope.safeApply();
    }
    $scope.sharedData.updatedAccountListAfterAccountUpdated=function(addedAccount){
      // console.log(addedAccount);
      findAndRemove($scope.details,'id',addedAccount.id);
      $scope.details.unshift(addedAccount);
      $scope.goBackChild();
      $scope.getFullAccount(addedAccount.id);
      $scope.showAccountList="show";
      $scope.safeApply();
    }
    $scope.scrollMoving=function(direction){
      // console.log("inscrollmoving");
      if(direction=="UP"){
        $scope.showBottomButton='hide';
      }else if(direction=="DOWN"){
        $scope.showBottomButton='show';
      }
      $scope.safeApply();
    }
    $scope.moreItemsOnScroll=function(module){
      // console.log("now it is scrolled to down");
      // console.log($scope.currentListPageNumber);
      // console.log($scope.infoOfDetails.page+1);
      if($scope.infoOfDetails.more_records==true && ($scope.infoOfDetails.page==$scope.currentListPageNumber)){
        // console.log("Hurrayyyy its more_records===true");
        $scope.currentListPageNumber=parseInt($scope.infoOfDetails.page)+1;
        $scope.safeApply();
        chrome.extension.sendRequest({name:'checkZatTime'},function(response){  
            var url = "https://crm.zoho."+response.datacenterExt+"/crm/v2/"+module+"?sort_by=Modified_Time&sort_order=desc&per_page=20&page="+(parseInt($scope.infoOfDetails.page)+1);
            if(response.status=="success"){
                var config = {headers:  { 'Authorization': 'Zoho-oauthtoken '+response.zat ,'X-ZOHO-SERVICE':'gadgets','X-CRM-ORG':response.orgId}};
                var getPotentials_api=$http.get(url,config);
                getPotentials_api.success( function(resp, status, headers, config) {
                    if(status==200){
                        // console.log(status);
                        // console.log(resp);
                        $scope.details=$scope.details.concat(resp.data);
                        $scope.sharedData.data=$scope.details;
                        $scope.infoOfDetails=resp.info;
                        $scope.safeApply();
                        // chrome.extension.sendRequest({name:'',redirect:'toStore',action:'',key:'potentialsListFromMenu',value:resp},function(response){
                        //     if(response.resp=="success"){
                        //         chrome.extension.sendRequest({name:'html/potential.html',redirect:'toContent',action:''});
                        //     }
                        // });
                    }else if(status==204){
                        // console.log(status);
                        // console.log(resp);
                        // chrome.extension.sendRequest({name:'',redirect:'toStore',action:'',key:'potentialsListFromMenu',value:{'data':[]}},function(response){
                        //     if(response.resp=="success"){
                        //         chrome.extension.sendRequest({name:'html/potential.html',redirect:'toContent',action:''});
                        //     }
                        // });
                    }else{
                        // console.log(status);
                        // console.log(resp);
                        // chrome.extension.sendRequest({name:'',redirect:'toStore',action:'',key:'potentialsListFromMenu',value:{}},function(response){
                        //     if(response.resp=="success"){
                        //         chrome.extension.sendRequest({name:'html/potential.html',redirect:'toContent',action:''});
                        //     }
                        // });
                    }
                });
                getPotentials_api.error( function(resp, status, headers, config) {
                    // console.log(status);
                    // console.log(resp);
                    // chrome.extension.sendRequest({name:'',redirect:'toStore',action:'',key:'potentialsListFromMenu',value:{}},function(response){
                    //     if(response.resp=="success"){
                    //         // chrome.extension.sendRequest({name:'html/potential.html',redirect:'toContent',action:''});
                    //     }
                    // });
                });
            }
        });
      }
    }
    $scope.goBackChild=function(){
      // console.log("goBackChild clicked");
      $scope.sharedData.id=null;
      $scope.$applyAsync();
      chrome.extension.sendRequest({name:'',redirect:'updateInnerPage',action:'updateInnerPage',val:null});
      window.document.getElementById('zc_innerIframeParentDiv').removeChild(window.document.getElementById('zc_innerIframePage'));
    }
    $scope.openWebsite=function(website){
      // console.log("openWebsite clicked");
      chrome.extension.sendRequest({name:'',redirect:'openUrlInNewTab',action:'',url:website},function(response){});
    }
    $scope.sharedData.succErrorInit=function(succError,succErrorMsg){
        // console.log(succError+":::::"+succErrorMsg);
        $scope.succError=succError;
        $scope.succErrorMsg=succErrorMsg;
        if(succError!='loading'){
            $timeout(function(){
                $scope.sharedData.succErrorReset();
            },3*1000);
        }
        $scope.safeApply();
    }
    $scope.sharedData.succErrorReset=function(){
        $scope.succError='';
        $scope.succErrorMsg='';
        $scope.safeApply();
    }
    function findAndReturn(array, property, value) {
    for(var i=0;i<array.length;i++){
      if(array[i][property] === value){
        return array[i];
      }
    }
  }
    function findAndRemove(array, property, value) {
      array.forEach(function(result, index) {
        if(result[property] === value) {
          //Remove from array
          array.splice(index, 1);
        }    
      });
    }

});